package classinfo;

public
class AccessFlags {
  public static final short ACC_PUBLIC =	0x0001;
  public static final short ACC_PRIVATE =	0x0002;
  public static final short ACC_PROTECTED =	0x0004;
  public static final short ACC_STATIC =	0x0008;
  public static final short ACC_FINAL =		0x0010;
  public static final short ACC_SYNCHRONIZED =	0x0020;
  public static final short ACC_VOLATILE =	0x0040;
  public static final short ACC_TRANSIENT =	0x0080;
  public static final short ACC_NATIVE =	0x0100;
  public static final short ACC_INTERFACE =	0x0200;
  public static final short ACC_ABSTRACT =	0x0400;
  public static final short ACC_STRICT =	0x0800;

  public static final short FLAG_BITS = 11;

  private static final String[] FLAG_NAMES = {
    "ACC_PUBLIC",
    "ACC_PRIVATE",
    "ACC_PROTECTED",
    "ACC_STATIC",
    "ACC_FINAL",
    "ACC_SYNCHRONIZED",
    "ACC_VOLATILE",
    "ACC_TRANSIENT",
    "ACC_NATIVE",
    "ACC_INTERFACE",
    "ACC_ABSTRACT",
    "ACC_STRICT"
  };


  public static String toString(short accFlags) {
    StringBuffer buf = new StringBuffer(BufManager.STRING_BUFFER_SIZE);
    boolean firstElement = true;

    short mask = 0x0001;
    for (int i = 0; i <= FLAG_BITS; i++) {
      if ((accFlags & mask) != 0) {
	if (!firstElement) {
	  buf.append(" | ");
	}
	buf.append(FLAG_NAMES[i]);

	firstElement = false;
      }

      mask <<= 1;
    }

    if (firstElement)
      return "default";
    else
      return buf.toString();
  }
}
