package classinfo;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import classinfo.attribute.*;

public class Attribute
{
  ConstantPoolReference name;	// 2 bytes
  int length;	// 4 bytes
	// ATTENTION: assume that length of attribute field is less than 2^31-1
  AttributeInfo attributeInfo;

  public Attribute(int name, int length,
			BufManager bufm, Vector CPTable)
	throws IOException {
    this.name = new ConstantPoolReference(name, CPTable);
    this.length = length;

    bufm.clearBuffer();
    String nameString =
	(String)((ConstantInPool)CPTable.elementAt(name)).value();
    if (nameString.equals(SourceFile.ATTRIBUTE_NAME)) {
      attributeInfo = new SourceFile(this.name, this.length, bufm, CPTable);
      return;
    }
    else if (nameString.equals(ConstantValue.ATTRIBUTE_NAME)) {
      attributeInfo = new ConstantValue(this.name, this.length, bufm, CPTable);
      return;
    }
    else if (nameString.equals(Code.ATTRIBUTE_NAME)) {
      attributeInfo = new Code(this.name, this.length, bufm, CPTable);
      return;
    }
    else if (nameString.equals(Exceptions.ATTRIBUTE_NAME)) {
      attributeInfo = new Exceptions(this.name, this.length, bufm, CPTable);
      return;
    }
    else if (nameString.equals(LineNumberTable.ATTRIBUTE_NAME)) {
      attributeInfo = new LineNumberTable(this.name, this.length,
							bufm, CPTable);
      return;
    }
    else if (nameString.equals(LocalVariableTable.ATTRIBUTE_NAME)) {
      attributeInfo = new LocalVariableTable(this.name, this.length,
							bufm, CPTable);
      return;
    }
    else if (nameString.equals(InnerClasses.ATTRIBUTE_NAME)) {
      attributeInfo = new InnerClasses(this.name, this.length,
							bufm, CPTable);
      return;
    }
    else if (nameString.equals(SGILineNumber.ATTRIBUTE_NAME)) {
      attributeInfo = new SGILineNumber(this.name, this.length, bufm, CPTable);
    }
    else {
      attributeInfo = new AttributeInfo(this.name, this.length, bufm);
    }
  }


  public void write(DataOutputStream out)
	throws java.io.IOException {
    out.writeShort((short)this.name.index());
    out.writeInt((int)length);

    this.attributeInfo.write(out);
  }


  public String toString() { return toString(""); }

  public String toString(String indent) {
    return attributeInfo.toString(indent);
  }
}
