package classinfo;

import java.io.*;

public
class BufManager {
  protected static final int STRING_BUFFER_SIZE = 100;

  protected static final int BUF_LENGTH = 8192;
  private byte[] buf = new byte[BUF_LENGTH];
  private int bufCount = 0;
  private int readBytes = 0;

  DataInputStream in;

  public BufManager(DataInputStream in) {
    this.in = in;
  }

  public void advance(int count) throws IOException {
    in.readFully(buf, bufCount, count);

/*
    int toRead = count;
    int read;
    while (toRead > 0) {
      read = in.read(buf, bufCount, toRead);
      if (read < 0)  throw new IOException("No more data to be read");
      toRead -= read;
      bufCount += read;
    }
*/

    this.readBytes += count;
  }

  public void advance(byte[] buf, int offset, int count)
	throws IOException {
    in.readFully(buf, offset, count);
/*
    int toRead = count;
    int read;
    while (toRead > 0) {
      read = in.read(buf, offset, toRead);
      if (read < 0)  throw new IOException("No more data to be read");
      toRead -= read;
      offset += read;
    }
*/

    this.readBytes += count;
  }

  public void clearBuffer() { bufCount = 0; }


  public int parseInt(int offset, int count) {
    int ret = 0;
    for (int i = 0; i < count; i++) {
      ret <<= 8;
      ret |= unsignedByteToInt(buf[offset + i]);
    }
    return ret;
  }

  public long parseLong(int offset, int count) {
    long ret = 0;
    for (int i = 0; i < count; i++) {
      ret <<= 8;
      ret |= unsignedByteToInt(buf[offset + i]);
    }
    return ret;
  }

  public float parseFloat(int offset, int count) {
    return Float.intBitsToFloat(parseInt(offset, count));
  }

  public double parseDouble(int offset, int count) {
    return Double.longBitsToDouble(parseLong(offset, count));
  }

  public String parseString(int offset, int count) {
    Utf utfForm = new Utf(buf, offset, count);
    return utfForm.toString();
  }

  public char parseChar(int offset) {
    return (char)parseInt(offset, 2);
  }

  public byte parseByte(int offset) {
    return buf[offset];
  }


  protected static int unsignedByteToInt(byte b) {
    int ret = (int)b;
    if (ret < 0)  ret += 256;

    return ret;
  }


  protected static String intToHexString(int i, int count) {
    byte[] buf0 = new byte[9];
    byte[] buf1 = new byte[9];
    int j;

    for (j = 0; j < count; j++) {
      buf0[j] = (byte)digitToHexChar(i & 0xf);
      i >>= 4;
    }
    for (j = 0; j < count; j++)  buf1[count - 1 - j] = buf0[j];

    return new String(buf1, 0, 0, count);
  }

  private static char digitToHexChar(int d) {
    if (d >= 0 && d <= 9)  return (char)('0' + d);
    else if (d >= 10 && d <= 35)  return (char)('a' + d - 10);
    return 'X';
  }
}
