package classinfo.attribute;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import classinfo.*;

public
class ConstantValue extends AttributeInfo {
  public static final String ATTRIBUTE_NAME = "ConstantValue";

  private ConstantPoolReference constantValue;

  public ConstantValue(ConstantPoolReference nameIndex, int length,
			BufManager bufm, Vector CPTable)
	throws IOException {
    super(nameIndex, length);

    bufm.clearBuffer();
    bufm.advance(2);

    constantValue = new ConstantPoolReference(bufm.parseInt(0, 2), CPTable);
  }


  public void write(DataOutputStream out)
	throws java.io.IOException {
    out.writeShort((short)this.constantValue.index());
  }


  public String toString() { return toString(""); }

  public String toString(String indent) {
    StringBuffer buf = new StringBuffer(AttributeInfo.STRING_BUFFER_SIZE);

    buf.append(super.toString(indent));

    buf.append(indent + "\tConstantValue: " + constantValue.toString());
    buf.append('\n');

    return buf.toString();
  }
}
