package classinfo.attribute;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import classinfo.*;

public class Exceptions extends AttributeInfo
{
  public static final String ATTRIBUTE_NAME = "Exceptions";

  int numberOfExceptions;	// 2 bytes
  ConstantPoolReference exceptions[];	// each entry is 2 bytes

  public Exceptions(ConstantPoolReference nameIndex, int length,
			BufManager bufm, Vector CPTable)
	throws IOException {
    super(nameIndex, length);

    bufm.clearBuffer();
    bufm.advance(2);

    numberOfExceptions = bufm.parseInt(0, 2);

    exceptions = new ConstantPoolReference[numberOfExceptions];
    for (int i = 0; i < numberOfExceptions; i++) {
      bufm.clearBuffer();
      bufm.advance(2);

      exceptions[i] = new ConstantPoolReference(bufm.parseInt(0, 2), CPTable);
    }
  }


  public void write(DataOutputStream out)
	throws java.io.IOException {
    out.writeShort((short)this.numberOfExceptions);
    for (int i = 0; i < numberOfExceptions; i++) {
      out.writeShort((short)exceptions[i].index());
    }
  }


  public String toString() { return toString(""); }

  public String toString(String indent) {
    StringBuffer buf = new StringBuffer(AttributeInfo.STRING_BUFFER_SIZE);

    buf.append(super.toString(indent));

    indent = indent + "\t";
    buf.append(indent + "Number of exceptions: " + numberOfExceptions + "\n");

    buf.append(indent + "Exception index table:\n");
    for (int i = 0; i < numberOfExceptions; i++) {
      buf.append(indent + "\t" + exceptions[i].toString() + "\n");
    }

    return buf.toString();
  }
}
