package classinfo.attribute;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import classinfo.*;

public
class SGILineNumber extends AttributeInfo {
  public static final String ATTRIBUTE_NAME = "SGILineNumber";

  int lineNumber;	// 2 bytes

  public SGILineNumber(ConstantPoolReference nameIndex, int length,
			BufManager bufm, Vector CPTable)
	throws IOException {
    super(nameIndex, length);

    bufm.clearBuffer();
    bufm.advance(2);

    // line number
    lineNumber = bufm.parseInt(0, 2);
  }


  public void write(DataOutputStream out)
	throws java.io.IOException {
    out.writeShort((short)lineNumber);
  }


  public String toString() { return toString(""); }

  public String toString(String indent) {
    StringBuffer buf = new StringBuffer(AttributeInfo.STRING_BUFFER_SIZE);

    buf.append(super.toString(indent));

    indent = indent + "\t";
    buf.append(indent + "Line number: " + lineNumber + "\n");

    return buf.toString();
  }
}
