package classinfo.attribute;

import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;
import classinfo.*;


public
class SourceFile extends AttributeInfo {
  public static final String ATTRIBUTE_NAME = "SourceFile";

  ConstantPoolReference sourceFile;

  public SourceFile(ConstantPoolReference nameIndex, int length,
			BufManager bufm, Vector CPTable)
	throws IOException {
    super(nameIndex, length);

    bufm.clearBuffer();
    bufm.advance(2);

    sourceFile = new ConstantPoolReference(bufm.parseInt(0, 2), CPTable);
  }


  public void write(DataOutputStream out)
	throws IOException {
    out.writeShort((short)this.sourceFile.index());
  }


  public String toString() { return toString(""); }

  public String toString(String indent) {
    StringBuffer buf = new StringBuffer(AttributeInfo.STRING_BUFFER_SIZE);

    buf.append(super.toString(indent));

    if (indent != null)  buf.append(indent);

    buf.append("\tSourceFile: " + sourceFile.toString() + "\n");

    return buf.toString();
  }
}
